﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using GeoTools.General;

namespace GeoTools.Views
{
    public partial class SceneViewer : UserControl, ISceneViewer
    {
        private IScene scene;

        public SceneViewer()
        {
            InitializeComponent();
        }
        
        public IScene Scene
        {
            get { return scene; }
            set 
            {
                scene = value;
                if (scene != null)
                    scene.PropertyChanged += Redraw;
            }
        }

        private void Redraw(object sender, PropertyChangedEventArgs e)
        {
            this.Refresh();
        }
        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            Draw(e.Graphics);
        }
        public void Draw(Graphics g)
        {
            if (scene == null)
                return;
            foreach (IGeoObject o in scene.Shapes)
                o.Draw(g);
        }
    }
}
