﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace GeoTools.Shapes
{
    internal class PolyLine : GeoBase, IGeoObject
    {
        double[][] points;

        public PolyLine()
        {
            points = new double[0][];
        }
        public PolyLine(List<KeyValuePair<string, double>> args)
        {
            int iX = 0;
            int iY = 0;
            points = new double[(int)Math.Max(args.Where(pair => pair.Key == "x").Count(), 
                args.Where(pair => pair.Key == "y").Count())][];
            foreach (var pair in args)
            {
                if (pair.Key == "x")
                    points[iX++] = new double[] { pair.Value, 0 };
            }
            foreach (var pair in args)
            {
                if (pair.Key == "y")
                    points[iY++][1] = pair.Value;
            }
        }
        public PolyLine(double[][] points)
        {
            this.points = points; // is this ok?
        }
        public double[][] Points
        {
            get { return points; }
            set { points = value; }
        }
        public override double Perimeter
        {
            get
            {
                double p = 0;
                for (int i = 1; i < points.Length; i++)
                {
                    p += Distance(points[i], points[i - 1]);
                }
                return p;
            }
        }
        public override void Draw(Graphics g)
        {
            for (int i = 1; i < points.Length; i++)
            {
                g.DrawLine(Pens.Black, (float)points[i - 1][0], (float)points[i - 1][1], (float)points[i][0], (float)points[i][1]);
            }
        }
        public override String ToString()
        {
            String retVal = "polyline [ ";
            for (int i = 0; i < points.Length; i++)
            {
                retVal += (points[i][0] + "," + points[i][1] + " ");
            }
            return retVal + "]";
        }
    }
}
