﻿using GeoTools;
using GeoTools.General;
using GeoTools.Shapes;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MyFirstGui
{
    public partial class Geometry : Form
    {
        Random rnd;
        IScene scene;

        public Geometry()
        {
            InitializeComponent();
            rnd = new Random();
        }

        // have a look in Form1.Designer.cs to see how this event handler is hooked to btnCircle!
        private void btnCircle_Click(object sender, EventArgs e)
        {
            tbMain.AppendText("You clicked New Circle - Circle is not implemented!" + Environment.NewLine);
        }

        private void btnSquare_Click(object sender, EventArgs e)
        {
            tbMain.AppendText("You clicked New Square" + Environment.NewLine);

            // generate random square entirely within scene viewer
            int x = rnd.Next(sceneViewer1.Width-20);
            int y = rnd.Next(sceneViewer1.Height-20);
            int lMax = sceneViewer1.Width - x;
            if (lMax > sceneViewer1.Height - y)
                lMax = sceneViewer1.Height - y;
            int l = rnd.Next(lMax);
            Square s = new Square(x, y, l);

            // insert new square into scene
            scene.Add(s);
        }

        private void btnTriangle_Click(object sender, EventArgs e)
        {
            tbMain.AppendText("You clicked New Triangle" + Environment.NewLine);
        }

        private void btnEllipse_Click(object sender, EventArgs e)
        {
            tbMain.AppendText("You clicked New Ellipse - Ellipse is not implemented!" + Environment.NewLine);
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            scene = new Scene();
            sceneViewer1.Scene = scene;
        }
    }
}
